Qwt User's Guide 6.0.2

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Signals | Public Member Functions | Protected Member Functions
QwtPlotPicker Class Reference

`#include <qwt_plot_picker.h>`

Inheritance diagram for QwtPlotPicker:
[legend]

List of all members.

## Signals

void | appended (const QPointF &pos)
void | moved (const QPointF &pos)
void | selected (const QPointF &pos)
void | selected (const QRectF &rect)
void | selected (const QVector< QPointF > &pa)
Signals inherited from QwtPicker
void | activated (bool on)
void | appended (const QPoint &pos)
void | changed (const QPolygon &selection)
void | moved (const QPoint &pos)
void | removed (const QPoint &pos)
void | selected (const QPolygon &polygon)

## Public Member Functions

| QwtPlotPicker (QwtPlotCanvas *)
| QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas *)
| QwtPlotPicker (int xAxis, int yAxis, RubberBand rubberBand, DisplayMode trackerMode, QwtPlotCanvas *)
virtual | ~QwtPlotPicker ()
QwtPlotCanvas * | canvas ()
const QwtPlotCanvas * | canvas () const
QwtPlot * | plot ()
const QwtPlot * | plot () const
virtual void | setAxis (int xAxis, int yAxis)
int | xAxis () const
int | yAxis () const
Public Member Functions inherited from QwtPicker
| QwtPicker (QWidget *parent)
| QwtPicker (RubberBand rubberBand, DisplayMode trackerMode, QWidget *)
virtual | ~QwtPicker ()
virtual void | drawRubberBand (QPainter *) const
virtual void | drawTracker (QPainter *) const
virtual bool | eventFilter (QObject *, QEvent *)
bool | isActive () const
bool | isEnabled () const
QWidget * | parentWidget ()
const QWidget * | parentWidget () const
virtual QRect | pickRect () const
ResizeMode | resizeMode () const
RubberBand | rubberBand () const
QPen | rubberBandPen () const
QPolygon | selection () const
void | setResizeMode (ResizeMode)
void | setRubberBand (RubberBand)
void | setRubberBandPen (const QPen &)
void | setStateMachine (QwtPickerMachine *)
void | setTrackerFont (const QFont &)
void | setTrackerMode (DisplayMode)
void | setTrackerPen (const QPen &)
const QwtPickerMachine * | stateMachine () const
QwtPickerMachine * | stateMachine ()
QFont | trackerFont () const
DisplayMode | trackerMode () const
QPen | trackerPen () const
QPoint | trackerPosition () const
virtual QRect | trackerRect (const QFont &) const
Public Member Functions inherited from QwtEventPattern
| QwtEventPattern ()
virtual | ~QwtEventPattern ()
void | initKeyPattern ()
void | initMousePattern (int numButtons)
bool | keyMatch (uint pattern, const QKeyEvent *) const
const QVector< KeyPattern > & | keyPattern () const
QVector< KeyPattern > & | keyPattern ()
bool | mouseMatch (uint pattern, const QMouseEvent *) const
const QVector< MousePattern > & | mousePattern () const
QVector< MousePattern > & | mousePattern ()
void | setKeyPattern (uint pattern, int key, int state=Qt::NoButton)
void | setKeyPattern (const QVector< KeyPattern > &)
void | setMousePattern (uint pattern, int button, int state=Qt::NoButton)
void | setMousePattern (const QVector< MousePattern > &)

## Protected Member Functions

virtual void | append (const QPoint &)
virtual bool | end (bool ok=true)
QRectF | invTransform (const QRect &) const
QPointF | invTransform (const QPoint &) const
virtual void | move (const QPoint &)
QRectF | scaleRect () const
virtual QwtText | trackerText (const QPoint &) const
virtual QwtText | trackerTextF (const QPointF &) const
QRect | transform (const QRectF &) const
QPoint | transform (const QPointF &) const
Protected Member Functions inherited from QwtPicker
virtual bool | accept (QPolygon &) const
virtual QPolygon | adjustedPoints (const QPolygon &) const
virtual void | begin ()
const QPolygon & | pickedPoints () const
virtual void | remove ()
virtual void | reset ()
const QWidget * | rubberBandWidget () const
virtual void | stretchSelection (const QSize &oldSize, const QSize &newSize)
const QWidget * | trackerWidget () const
virtual void | transition (const QEvent *)
virtual void | updateDisplay ()
virtual void | widgetEnterEvent (QEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | widgetLeaveEvent (QEvent *)
virtual void | widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetWheelEvent (QWheelEvent *)
Protected Member Functions inherited from QwtEventPattern
virtual bool | keyMatch (const KeyPattern &, const QKeyEvent *) const
virtual bool | mouseMatch (const MousePattern &, const QMouseEvent *) const

## Additional Inherited Members

Public Types inherited from QwtPicker
enum | DisplayMode { AlwaysOff, AlwaysOn, ActiveOnly }
enum | ResizeMode { Stretch, KeepSize }
enum | RubberBand { NoRubberBand = 0, HLineRubberBand, VLineRubberBand, CrossRubberBand, RectRubberBand, EllipseRubberBand, PolygonRubberBand, UserRubberBand = 100 }
Public Types inherited from QwtEventPattern
enum | KeyPatternCode { KeySelect1, KeySelect2, KeyAbort, KeyLeft, KeyRight, KeyUp, KeyDown, KeyRedo, KeyUndo, KeyHome, KeyPatternCount }
enum | MousePatternCode { MouseSelect1, MouseSelect2, MouseSelect3, MouseSelect4, MouseSelect5, MouseSelect6, MousePatternCount }
Public Slots inherited from QwtPicker
void | setEnabled (bool)

## Detailed Description

QwtPlotPicker provides selections on a plot canvas.

QwtPlotPicker is a QwtPicker tailored for selections on a plot canvas. It is set to a x-Axis and y-Axis and translates all pixel coordinates into this coodinate system.

## Constructor & Destructor Documentation

QwtPlotPicker::QwtPlotPicker | ( | QwtPlotCanvas * | canvas | ) |

explicit

Create a plot picker.

The picker is set to those x- and y-axis of the plot that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

Parameters:

  canvas | Plot canvas to observe, also the parent object

See also:
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

QwtPlotPicker::QwtPlotPicker | ( | int | xAxis,
|  | int | yAxis,
|  | QwtPlotCanvas * | canvas
| ) |  |

explicit

Create a plot picker

Parameters:

  xAxis | Set the x axis of the picker
  yAxis | Set the y axis of the picker
  canvas | Plot canvas to observe, also the parent object

See also:
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

QwtPlotPicker::QwtPlotPicker | ( | int | xAxis,
|  | int | yAxis,
|  | RubberBand | rubberBand,
|  | DisplayMode | trackerMode,
|  | QwtPlotCanvas * | canvas
| ) |  |

explicit

Create a plot picker

Parameters:

  xAxis | X axis of the picker
  yAxis | Y axis of the picker
  rubberBand | Rubberband style
  trackerMode | Tracker mode
  canvas | Plot canvas to observe, also the parent object

See also:
  QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

## Member Function Documentation

void QwtPlotPicker::append | ( | const QPoint & | pos | ) |

protectedvirtual

Append a point to the selection and update rubberband and tracker.

Parameters:

  pos | Additional point

See also:
  isActive, begin(), end(), move(), appended()

Note:
  The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

void QwtPlotPicker::appended | ( | const QPointF & | pos | ) |

signal

A signal emitted when a point has been appended to the selection

Parameters:

  pos | Position of the appended point.

See also:
  append(). moved()

bool QwtPlotPicker::end | ( | bool | ok = `true` | ) |

protectedvirtual

Close a selection setting the state to inactive.

Parameters:

  ok | If true, complete the selection and emit selected signals otherwise discard the selection.

Returns:
  true if the selection is accepted, false otherwise

Reimplemented from QwtPicker.

Reimplemented in QwtPlotZoomer.

QRectF QwtPlotPicker::invTransform | ( | const QRect & | rect | ) | const

protected

Translate a rectangle from pixel into plot coordinates

Returns:
  Rectangle in plot coordinates

See also:
  transform()

QPointF QwtPlotPicker::invTransform | ( | const QPoint & | pos | ) | const

protected

Translate a point from pixel into plot coordinates

Returns:
  Point in plot coordinates

See also:
  transform()

void QwtPlotPicker::move | ( | const QPoint & | pos | ) |

protectedvirtual

Move the last point of the selection

Parameters:

  pos | New position

See also:
  isActive, begin(), end(), append()

Note:
  The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

void QwtPlotPicker::moved | ( | const QPointF & | pos | ) |

signal

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:

  pos | Position of the moved last point of the selection.

See also:
  move(), appended()

QRectF QwtPlotPicker::scaleRect | ( |  | ) | const

protected

Return normalized bounding rect of the axes

See also:
  QwtPlot::autoReplot(), QwtPlot::replot().

void QwtPlotPicker::selected | ( | const QPointF & | pos | ) |

signal

A signal emitted in case of selectionFlags() & PointSelection.

Parameters:

  pos | Selected point

void QwtPlotPicker::selected | ( | const QRectF & | rect | ) |

signal

A signal emitted in case of selectionFlags() & RectSelection.

Parameters:

  rect | Selected rectangle

void QwtPlotPicker::selected | ( | const QVector< QPointF > & | pa | ) |

signal

A signal emitting the selected points, at the end of a selection.

Parameters:

  pa | Selected points

void QwtPlotPicker::setAxis | ( | int | xAxis,
|  | int | yAxis
| ) |  |

virtual

Set the x and y axes of the picker

Parameters:

  xAxis | X axis
  yAxis | Y axis

Reimplemented in QwtPlotZoomer.

QwtText QwtPlotPicker::trackerText | ( | const QPoint & | pos | ) | const

protectedvirtual

Translate a pixel position into a position string

Parameters:

  pos | Position in pixel coordinates

Returns:
  Position string

Reimplemented from QwtPicker.

QwtText QwtPlotPicker::trackerTextF | ( | const QPointF & | pos | ) | const

protectedvirtual

Translate a position into a position string.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the double to string conversion is "%.4f".

Parameters:

  pos | Position

Returns:
  Position string

QRect QwtPlotPicker::transform | ( | const QRectF & | rect | ) | const

protected

Translate a rectangle from plot into pixel coordinates

Returns:
  Rectangle in pixel coordinates

See also:
  invTransform()

QPoint QwtPlotPicker::transform | ( | const QPointF & | pos | ) | const

protected

Translate a point from plot into pixel coordinates

Returns:
  Point in pixel coordinates

See also:
  invTransform()